<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BorderCrossingSelection StructType
 * @subpackage Structs
 */
class BorderCrossingSelection extends AbstractStructBase
{
    /**
     * The IncludeTachoTimes
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var bool
     */
    public $IncludeTachoTimes;
    /**
     * The IncludeObcTimes
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var bool
     */
    public $IncludeObcTimes;
    /**
     * The IncludeCoDriverData
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var bool
     */
    public $IncludeCoDriverData;
    /**
     * The DateTimeRangeSelection
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\DateTimeRangeSelection
     */
    public $DateTimeRangeSelection;
    /**
     * The Vehicles
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfIdentifierVehicle
     */
    public $Vehicles;
    /**
     * The Drivers
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfIdentifier
     */
    public $Drivers;
    /**
     * Constructor method for BorderCrossingSelection
     * @uses BorderCrossingSelection::setIncludeTachoTimes()
     * @uses BorderCrossingSelection::setIncludeObcTimes()
     * @uses BorderCrossingSelection::setIncludeCoDriverData()
     * @uses BorderCrossingSelection::setDateTimeRangeSelection()
     * @uses BorderCrossingSelection::setVehicles()
     * @uses BorderCrossingSelection::setDrivers()
     * @param bool $includeTachoTimes
     * @param bool $includeObcTimes
     * @param bool $includeCoDriverData
     * @param \StructType\DateTimeRangeSelection $dateTimeRangeSelection
     * @param \ArrayType\ArrayOfIdentifierVehicle $vehicles
     * @param \ArrayType\ArrayOfIdentifier $drivers
     */
    public function __construct($includeTachoTimes = null, $includeObcTimes = null, $includeCoDriverData = null, \StructType\DateTimeRangeSelection $dateTimeRangeSelection = null, \ArrayType\ArrayOfIdentifierVehicle $vehicles = null, \ArrayType\ArrayOfIdentifier $drivers = null)
    {
        $this
            ->setIncludeTachoTimes($includeTachoTimes)
            ->setIncludeObcTimes($includeObcTimes)
            ->setIncludeCoDriverData($includeCoDriverData)
            ->setDateTimeRangeSelection($dateTimeRangeSelection)
            ->setVehicles($vehicles)
            ->setDrivers($drivers);
    }
    /**
     * Get IncludeTachoTimes value
     * @return bool
     */
    public function getIncludeTachoTimes()
    {
        return $this->IncludeTachoTimes;
    }
    /**
     * Set IncludeTachoTimes value
     * @param bool $includeTachoTimes
     * @return \StructType\BorderCrossingSelection
     */
    public function setIncludeTachoTimes($includeTachoTimes = null)
    {
        // validation for constraint: boolean
        if (!is_null($includeTachoTimes) && !is_bool($includeTachoTimes)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($includeTachoTimes, true), gettype($includeTachoTimes)), __LINE__);
        }
        $this->IncludeTachoTimes = $includeTachoTimes;
        return $this;
    }
    /**
     * Get IncludeObcTimes value
     * @return bool
     */
    public function getIncludeObcTimes()
    {
        return $this->IncludeObcTimes;
    }
    /**
     * Set IncludeObcTimes value
     * @param bool $includeObcTimes
     * @return \StructType\BorderCrossingSelection
     */
    public function setIncludeObcTimes($includeObcTimes = null)
    {
        // validation for constraint: boolean
        if (!is_null($includeObcTimes) && !is_bool($includeObcTimes)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($includeObcTimes, true), gettype($includeObcTimes)), __LINE__);
        }
        $this->IncludeObcTimes = $includeObcTimes;
        return $this;
    }
    /**
     * Get IncludeCoDriverData value
     * @return bool
     */
    public function getIncludeCoDriverData()
    {
        return $this->IncludeCoDriverData;
    }
    /**
     * Set IncludeCoDriverData value
     * @param bool $includeCoDriverData
     * @return \StructType\BorderCrossingSelection
     */
    public function setIncludeCoDriverData($includeCoDriverData = null)
    {
        // validation for constraint: boolean
        if (!is_null($includeCoDriverData) && !is_bool($includeCoDriverData)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($includeCoDriverData, true), gettype($includeCoDriverData)), __LINE__);
        }
        $this->IncludeCoDriverData = $includeCoDriverData;
        return $this;
    }
    /**
     * Get DateTimeRangeSelection value
     * @return \StructType\DateTimeRangeSelection|null
     */
    public function getDateTimeRangeSelection()
    {
        return $this->DateTimeRangeSelection;
    }
    /**
     * Set DateTimeRangeSelection value
     * @param \StructType\DateTimeRangeSelection $dateTimeRangeSelection
     * @return \StructType\BorderCrossingSelection
     */
    public function setDateTimeRangeSelection(\StructType\DateTimeRangeSelection $dateTimeRangeSelection = null)
    {
        $this->DateTimeRangeSelection = $dateTimeRangeSelection;
        return $this;
    }
    /**
     * Get Vehicles value
     * @return \ArrayType\ArrayOfIdentifierVehicle|null
     */
    public function getVehicles()
    {
        return $this->Vehicles;
    }
    /**
     * Set Vehicles value
     * @param \ArrayType\ArrayOfIdentifierVehicle $vehicles
     * @return \StructType\BorderCrossingSelection
     */
    public function setVehicles(\ArrayType\ArrayOfIdentifierVehicle $vehicles = null)
    {
        $this->Vehicles = $vehicles;
        return $this;
    }
    /**
     * Get Drivers value
     * @return \ArrayType\ArrayOfIdentifier|null
     */
    public function getDrivers()
    {
        return $this->Drivers;
    }
    /**
     * Set Drivers value
     * @param \ArrayType\ArrayOfIdentifier $drivers
     * @return \StructType\BorderCrossingSelection
     */
    public function setDrivers(\ArrayType\ArrayOfIdentifier $drivers = null)
    {
        $this->Drivers = $drivers;
        return $this;
    }
}
